<?php

function gumtheme_reg_widget_instagram(){
    register_widget('gumtheme_widget_instagram');
}
add_action('widgets_init', 'gumtheme_reg_widget_instagram');

class gumtheme_widget_instagram extends WP_Widget{

    public $fields = array(
        array(
            'id' => 'widget_insta_feed_alert',
            'html_id' => 'widget_insta_feed_alert',
            'input_type'=>'plainText',
            'label'=>'Alert',
            'value'=>"",
            'wrapper_class' => 'gum_alert',
            'label_class' => '',
            'input_class'=>"",
            'desc'=> "To display Instagram feed firstly give credentials under gumtheme plugin 'Social Sites'",
            'error_message'=> "",
            'validate' => '',
            'process' => "",
            'horizontal_field'=>false
        ),
        array(
            'id' => 'widget_insta_feed_title',
            'html_id' => 'widget_insta_feed_title',
            'input_type'=>'text',
            'label'=>'Title',
            'value'=>"Instagram",
            'wrapper_class' => 'gum_title',
            'label_class' => '',
            'input_class'=>"",
            'desc'=> "",
            'error_message'=> "",
            'validate' => '',
            'process' => "",
            'horizontal_field'=>false
        ),
        array(
            'id' => 'widget_insta_feed',
            'html_id' => 'widget_insta_feed',
            'input_type'=>'single_checkbox',
            'label'=>'Enable Insta Feed',
            'value'=>"0",
            'wrapper_class' => 'gum_widget_insta_feed',
            'label_class' => '',
            'input_class'=>"",
            'desc'=> "mark tick this checkbox if you want to show instagram feed",
            'error_message'=> "",
            'validate' => '',
            'process' => "",
            'horizontal_field'=>false
        ),   
        array(
            'id' => 'widget_insta_feed_count',
            'html_id' => 'widget_insta_feed_count',
            'input_type'=>'text',
            'label'=>'Images to show',
            'value'=>"0",
            'wrapper_class' => 'gum_insta_feed_count',
            'label_class' => '',
            'input_class'=>"",
            'desc'=> "enter the number of images to show",
            'error_message'=> "",
            'validate' => '',
            'process' => "",
            'horizontal_field'=>false
        ),     
    );

    function __construct(){
        $widget_options = array( 
            'classname' => 'gum-insta-feed',
            'description' => __('Gumthemes Instagram Feed')
        );
        parent::__construct('gumtheme-insta-feed', __('Gumthemes - Instagram Feed'), $widget_options);
    }

    function widget($args, $instance){
        extract($args);

        if(!empty($before_widget)) echo $before_widget;

		    Gum_widget_html::Gumtheme_insta_feed($this->fields, $instance);

        if(!empty($after_widget))  echo $after_widget;
    }

    function update($new_instance, $old_instance) {

        $instance = $new_instance;
        foreach($this->fields as $field){
            $raw_id = $field['id'];
            $field['id'] = $this->get_field_name($field['id']);

            if(isset($new_instance[$raw_id])) $instance[$raw_id] = $new_instance[$raw_id];
        }
        return $instance;
    }
    function form($instance) {

		foreach($this->fields as $field){

			if(!empty($instance[$field['id']])) $field['value'] = $instance[$field['id']];

			$meta_object = $field['input_type'];

			$field['id'] = $this->get_field_name($field['id']);
			$field['html_id'] = $this->get_field_id($field['id']);

			echo Gum_Be_Widget_Html::$meta_object($field);
        }
        

    }
}
