<?php
/**
 * Gum_html calss - General HTML ouputs.
 * All the grids-blocks methods goes here.
 * @author Gumthemes.com
 */
class Gum_html extends Gum_block {

		public static $global_settings = array(
			'grid_show_cat' => 1,
			'grid_show_date' => 1,
			'grid_show_author' => 0,
			'grid_show_views' => 0,
			'grid_show_likes' => 0,
			'grid_show_comment_count' => 0,
			'grid_date_type' => 'date_ago',
			'grid_custom_date_format' => 'M j, Y',
		);
		public static $single_post_setting = array(
			'show_post_breadcrumb' => 1,
			'show_post_date' => 1,
			'post_date_type' => 'custom_date',
			'post_date_format' => 'M d, Y',
			'post_date_pretext' => 'On ',
			'show_post_author' => 1,
			'post_author_pretext' => 'By ',
			'show_post_author_image' => 1,
			'show_post_views' => 1,
			'show_post_comment_count' => 1,
			'show_post_likes' => 1,
			'show_post_social_share_header' => 1,
			'show_post_social_share_bottom' => 0,
			'show_post_author_info' => 0,
			'show_more_author_posts' => 0,
			'show_similar_posts' => 1,
			'gum_single_post_template' => 'default',
			'gum_single_post_sidebar' => 'default',
		);

	/**
	* Social Share Icon header
	* @param
	* @return string	HTML
	*/
	public static function get_the_socialshare_icons_header(){
		global $gumtheme_options;
		$show_post_social_share_header = (isset($gumtheme_options['show_post_social_share_header']))? $gumtheme_options['show_post_social_share_header'] :  self::$single_post_setting['show_post_social_share_header'];
		if($show_post_social_share_header == 1){
			$output = GumHelper::socialshare_icons();
			return $output;
		}

		return false;
	}

	/**
	* Social Share Icon footer
	* @param
	* @return string	HTML
	*/
	public static function get_the_socialshare_icons_footer(){
		global $gumtheme_options;
		$show_post_social_share_bottom = (isset($gumtheme_options['show_post_social_share_bottom']))? $gumtheme_options['show_post_social_share_bottom'] :  self::$single_post_setting['show_post_social_share_bottom'];
		if($show_post_social_share_bottom == 1){
			$output = GumHelper::socialshare_icons();
			return $output;
		}

		return false;
	}
	public static function sanitize_grid_args($args){
		foreach ($args as $key => $value) {
			if(gettype($value) == 'boolean'){
				if($value == true)
					$args[$key]=1;
				else
					$args[$key]=0;
			}
		}
		return $args;
	}

	/**
	* BreadCrumb
	* @param
	* @return string	HTML
	*/
	public static function gum_post_breadcrumb(){

		global $post, $gumtheme_options;

		$show_post_breadcrumb = (isset($gumtheme_options['show_post_breadcrumb']))? $gumtheme_options['show_post_breadcrumb'] :  self::$single_post_setting['show_post_breadcrumb'];

		if($show_post_breadcrumb == 1){
			$categories = get_the_category();

			$html = '<div class="gum-breadcrumb">';
				$html .= '<ul  itemscope itemtype="http://schema.org/BreadcrumbList">';
				$html .= '<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
			      			<a href="'.esc_url( home_url( '/' ) ).'" title="home" itemprop="item" rel="home">
			      				<i class="fa fa-home" aria-hidden="true"></i> '.__("Home", "gumtheme").'
				  			</a>
				  			<meta itemprop="position" content="1" />
				  		</li>';
				if(!empty($categories)){
					$html .= '<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
								<a href="'.get_term_link( $categories[0] ).'" title="home" itemprop="item">
									<span itemprop="name">'.$categories[0]->name.'</span>
								</a>
								<meta itemprop="position" content="2" />
							</li>';
				}
				$html .= '<li class="last" itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
							<span itemprop="name">'.get_the_title($post).'</span>
							<meta itemprop="position" content="3" />
						</li>';
				$html .= "</ul>";
			$html .= "</div><!-- breadcrumb -->";
			return $html;
		}
		return false;
	}

	public static function sidebar_html($options){

		global $gumtheme_options;
		$sticky_sidebar_class="";

		$returnData=[];

		$returnData['html']="";

		if(!empty($options['id']))
			$id = $options['id'];
	    else
	    	$id = rand();

		if(!empty($options['sidebar'])) $gum_sidebar_id = $options['sidebar'];
		else $gum_sidebar_id = 'sidebar-1';

		$sidebar_with_sticky = $gum_sidebar_id . "_sticky";

		if(!empty($gumtheme_options[$sidebar_with_sticky ])) $sticky_sidebar_class =" sticky-sidebars";

		$returnData['html'].="<div class='widget-area gum-sidebar-wrapper $sticky_sidebar_class' role='complementary' id='sidebar_".$id."'>";
	 	$returnData['html'].="<div class='gum-sidebar'>";
	 		ob_start();
			dynamic_sidebar($gum_sidebar_id);
			$sidebarData = ob_get_contents();
			ob_end_clean();
		$returnData['html'].=$sidebarData;
		$returnData['html'].="</div></div>";

		return $returnData;

	}

	public static function post_recent_posts_html($options){
		$returndata=[];
		$returndata['html']="";

		if(!empty($options['id']))
	 		$id = $options['id'];
	    else{
		    $id = rand();
			$options['id'] = $id;
		}

		$counter = 1;
		$block_html = gum_html::recent_posts_with_pagination($options);

		$returndata['html'].="<div class='gum-grid-block-wrapper gum-grid-block-recent content-area gum-grid-block-wrapper-".$id."'>";

		$returndata['html'].=Gum_html::posts_block_header_with_nav($options);
		$returndata['html'].="<div class='gum-block-loading-wrapper'>";
		$returndata['html'].="<div id='gum-gb-wrapper-".$id."' class='gum-gb-wrapper'>";
		$returndata['html'].=$block_html['html'];
		$returndata['html'].="</div><!-- gum-gb-wrapper -->";
		$returndata['html'].=Gum_html::spinner();
		$returndata['html'].="</div><!-- gum-block-loading-wrapper -->";
		$returndata['html'].=Gum_html::posts_block_footer($options);
		$returndata['html'].="</div>";
		$returndata['html'].="<script type='text/javascript'>";

		$returndata['html'].="gumBlock.block_".$id."= {'block' : '_posts_recent_posts', 'options' : ".json_encode($options).", 'type' : 'cat'};";
		$returndata['html'].="</script>";

		return $returndata;
	}

	public static function full_grid_1($options){

		$counter = 1;
		$class = '';
		$return_data = array();
		$html = "";
		$posts_helper = GumHelper::getposts($options);
		$the_query = $posts_helper['the_query'];
		if($the_query->have_posts()){

			$count = 1;
			$remaining_posts = '';
			$args = $options;
			if(isset($posts_helper['posts_view_count'])) $args['posts_view_count'] = $posts_helper['posts_view_count'];
			while ( $the_query->have_posts() ) : $the_query->the_post();

				if(0 == $count % 2 ) $odd_even_class = " gum-block-even";
				else  $odd_even_class = " gum-block-odd";

				if($count == 1){

					$first_grid_post = gum_html::fullGrid_block_1($args);

				} else{

					$args['class'] = $odd_even_class.' full_grid_1-'.$count;

					$remaining_posts .= gum_html::fullGrid_block_2($args);
				}
				$count++;

			endwhile;
			wp_reset_postdata();

			$return_data['html'] ="<div class='gum_posts_grid_slide row'>
						$first_grid_post

						<div class='col-sm-6  gum_grid_small'>
							<div class='row'>
								$remaining_posts
								<div class='clearfix'></div>
							</div><!-- row -->

						</div><!-- gum_grid_small -->
						<div class='clearfix'></div>
					</div><!-- row -->";
		}
		return $return_data;
	}
	public static function full_block_1_html($options,$classes=''){


		$return_data=[];

		$return_data['html']="";

		$return_data['html'].="<div class='$classes fullgrid-1-wrapper gum-cat-wrapper gum-cat-wrapper-block_1'>";
		$return_data['html'] .= Gum_html::posts_block_header_with_nav($options);
		$data =  gum_html::full_grid_1($options);

		$return_data['html'].=$data['html'];

		$return_data['html'].="</div><!-- container -->";

		return $return_data;
	}

	
	/**
	* Carousel 1 HTML
	* @param array	$options
	* @return string	HTML
	*/


	public static function getPost($singleCategory){
	        $postHtml = '';

	        $posts_helper = GumHelper::getposts(array( 'posts_per_page'=>1, 'category_id' => $singleCategory->term_id ));
	        $the_query = $posts_helper['the_query'];

	        while( $the_query->have_posts()) {
	            $the_query->the_post();

	            $postId = get_the_ID();
	            $imgSrc = gum_html::get_featured_image($postId, 'gum_450X550');
	            $category = get_the_category( $postId );
	            $categoryLink = get_category_link($category[0]->term_id);

	            //var_dump($category[0]->slug);
	            $postHtml .= "<div class='slider-post-wrapper'>";
				    $postHtml .= "<div class='img-holder'>";
				        $postHtml .= "<img src='$imgSrc' alt=''>";
				    $postHtml .= "</div>";
				    $postHtml .= "<div class='cat-heading'>";
				        $postHtml .= "<a href='category/".$category[0]->slug."'><span>".$category[0]->name."</span></a>";
				    $postHtml .= "</div>";
				$postHtml .= "</div>";
	        }

	        return $postHtml;
	}

	public static function categories_grid_html($options){

		$size_class = '';
		$row_class = '';

	    if(!empty($options['gum_size'])) $size_class = $options['gum_size'];
		if($size_class == 'container') $row_class = 'row';

		if(!empty($options['id'])) $id = $options['id'];
		else $id = rand();


			if(!empty($options['id'])) $id = $options['id'];
	    	else{
				$id = rand();
				$options['id'] = $id;
			 }
			$postHtml = '';

			$args1=array(
	    		'hide_empty'  => 0,
	    		'show_count' => 0,
	    		'order' => 'ASC',
				'orderby' => 'name',
	    	);
	        $myCategories = get_categories($args1);
	        //echo '<pre>';
	        //var_dump($myCategories);
	        //echo '</pre>';
	        foreach($myCategories as $singleCategory){
	            $postHtml .= gum_html::getPost($singleCategory);
	        }
	        $data=[];
			$data['html']="";


			$data['html'] = "<div class='gum-carousel_1-wrapper gum_posts_grid_wrapper border-box main-cat-carosel'>";
		$data['html'] .= Gum_html::posts_block_header_with_nav($options);

			$data['html'] .= '<div class="gum_posts_grid_wrapper gum_carousel_1 '.$size_class.'" id="gum_carousel_1_'.$id.'">';
			$data['html'] .= '<div class="'.$row_class.' gum_post_fullgrid gum_posts_grid_slide gum-carousel">';

			$data['html'] .=$postHtml;
			$data['html'] .= '</div><!-- gum-carousel -->
								</div><!-- gum_carousel_1 -->';
		$data['html'] .= "</div><!-- .gum-carousel_1-wrapper --> ";

			return $data;
	}
	/**
	* Slider 1 HTML
	* @param array	$options
	* @return string	HTML
	*/
	public static function slider_1($options){

		$return_data = array();
		$return_data['html'] = '';
		$posts_helper = GumHelper::getposts($options);
		$the_query = $posts_helper['the_query'];
		if(!empty($options['id'])) $id = $options['id'];
		else $id = rand();

		if($the_query->have_posts()){

			$count = 0;
			$args = $options;
			if(isset($posts_helper['posts_view_count'])) $args['posts_view_count'] = $posts_helper['posts_view_count'];


			$return_data['html'] .= "<div class='gum_slider_1 '>";
			$return_data['html'] .= "<div class='slide-banner-sec gum-slider' id='gum_slider_grid_$id'>";

			if(empty($args['class'])) $args['class'] = '';
			while ( $the_query->have_posts() ){
				 $the_query->the_post();

				$args['class'] = "item-wrapper";
	 			$args['image_size'] = 'gum_450X550';

				$return_data['html'] .= gum_html::slider_block($args);

				$count++;
			}
			wp_reset_postdata();

			$return_data['html'] .= "</div><!-- gum_slider_1 -->
				</div><!-- gum_full_grid_$id -->";
	   	}

	   return $return_data;

	}

	public static function slider_1_html($options){

		$return_data=[];

		$return_data['html'] = "<div class='gum-slider_1-wrapper gum_posts_grid_wrapper'>";
		$return_data['html'] .= Gum_html::posts_block_header_with_nav($options);

		$data = gum_html::slider_1($options);

		$return_data['html'].=$data['html'];

		$return_data['html'] .= "</div><!-- .gum-slider_1-wrapper --> ";
		return $return_data;
	}
	/**
	* Posts Grid 1
	* @param array	$options
	* @return string	HTML
	*/
	public static function posts_grid_1($options, $class=''){

		$count = 0;
		$data = array();
		$remaining_posts = '';
		$first_grid_post ='';
		$posts_helper = GumHelper::getposts($options);
		$the_query = $posts_helper['the_query'];

		$args = $options;
		if(isset($posts_helper['posts_view_count'])) $args['posts_view_count'] = $posts_helper['posts_view_count'];

		$data['post_count'] = $the_query->post_count;

		if($the_query->have_posts()){
			while ( $the_query->have_posts() ) { $the_query->the_post();


				$args['excerpt_word_count'] = "20";
				$args['show_excerpt'] = "1";
				$args['read_more']='1';
	 			// Use large image if published in full width area
				$args['show_likes']='1';
				$args['show_views']='1';
				$args['show_comment_count']='1';
				$args['show_date']='1';


	 			if(0 == $count){
	 			 	$odd_event = "gum-block-even";
	 			 	$args['class'] ='col-lg-6 '. $odd_event.' left-sec gum-grid-block-1-'.$count;
					$args['image_size'] = 'gum_700X450';
					$args['title_word_count'] = "12";

					$first_grid_post .= gum_html::block_1($args);
	 			}
				else{
					$odd_event = "gum-block-odd";
					$args['class'] = $odd_event.' left-sec sec-pd right-sec gum-grid-block-1-'.$count;
					$args['image_size'] = 'gum_170X170';
					$args['title_word_count'] = "8";
					$remaining_posts .= gum_html::block_2($args);

				}

				$count++;
			}
			wp_reset_postdata();

			$data['html'] = "<div class='gum-grid-blocks gum-gb-row'>
					<div class='row no-gutters'>
						$first_grid_post
						<div class='col-lg-6'>
						<div class='right-side-wrapper'>
						$remaining_posts
						</div>
						</div>
					</div>
				</div><!-- gum-grid-blocks -->";
			return $data;
		}
		else return false;

	}

	public static function post_grid_1_html($options){
	$options=self::sanitize_grid_args($options);

		if(!empty($options['id'])) $id = $options['id'];
    	else{
			$id = rand();
			$options['id'] = $id;
		 }
		$data = [];
		$block_html = gum_html::posts_grid_1($options);
			$data['html'] = '';
			$data['html'] .= '<div class="gum-grid-block-wrapper gum-grid-block-1 gum-grid-block-wrapper-'.$id.' border-box">';
			$data['html'] .= Gum_html::posts_block_header_with_nav($options);
			$data['html'] .= '<div class="gum-block-loading-wrapper">';
			$data['html'] .= '<div id="gum-gb-wrapper-'.$id.'" class="gum-gb-wrapper">';
			$data['html'] .= $block_html['html'];
			$data['html'] .= '</div><!-- gum-gb-wrapper -->';
			$data['html'] .=  Gum_html::spinner();
			$data['html'] .= '</div><!-- gum-block-loading-wrapper -->';
			$data['html'] .= Gum_html::posts_block_footer($options);
			$data['html'] .= '</div><!-- .gum-grid-block-wrapper -->';
			$data['html'] .= '<script type="text/javascript">
				gumBlock.block_'.$id.'= {"block" : "posts_grid_1", "options" : '.json_encode($options).', "type" : "cat"};
			</script>';
		return $data;
	}
	/**
	* Post Grid 2 HTML
	* @param array	$options
	* @param string $class
	* @return string	HTML
	*/
	public static function posts_grid_2($options, $class=''){
		$count = 0;
		$data = array();
		$first_grid_post = '';
		$remaining_posts = '';
		$posts_helper = GumHelper::getposts($options);
		$the_query = $posts_helper['the_query'];

		$args = $options;
		if(isset($posts_helper['posts_view_count'])) $args['posts_view_count'] = $posts_helper['posts_view_count'];

		$data['post_count'] = $the_query->post_count;
		$has_review = 0;
		if($the_query->have_posts()){
			while ( $the_query->have_posts() ) { $the_query->the_post();
				// check if any post has reviews, assign a class to main div to set height etc.
				if(empty($has_review)){
					$review_html = self::get_post_review(get_the_ID());
					if(!empty($review_html) && strlen($review_html)) $has_review = 1;
				}

				if($count == 0){
					// Use large image if published in full width area
					$args['image_size'] = 'gum_700X450';
			 		$first_grid_post = gum_html::block_3($args);
				}
				else{
		 			// Use large image if published in full width area
		 			$args['image_size'] = 'gum_170X170';
					$remaining_posts .="<div class='col-md-6'>";
		 			$remaining_posts .= gum_html::block_2($args);
					$remaining_posts .="</div>";

				}

				$count++;
			}
			wp_reset_postdata();

			$review_class= '';
			if(!empty($has_review)) $review_class = 'gum-has-reviews';
			$data['html'] = "<div class='gum-grid-blocks gum-gb-row tab-pane show active $review_class '>
							<div class='row'>
								$remaining_posts
							</div><!-- row -->


						<div class='gum-block-2-main $review_class description-posts'>
								$first_grid_post
						</div><!-- gum_grid_small -->
				</div><!-- gum-grid-blocks -->";
			return $data;
		}
		else return false;

	}
	public static function post_grid_2_html($options){
	$options=self::sanitize_grid_args($options);

		if(!empty($options['id'])) $id = $options['id'];
    	else{
			$id = rand();
			$options['id'] = $id;
		 }
		$data = [];
		$block_html = gum_html::posts_grid_2($options);
			$data['html'] = '';
			$data['html'] .= '<div class="gum-grid-block-wrapper gum-grid-block-2 gum-grid-block-wrapper-'.$id.' border-box box-style-4 dark-bg">';
			$data['html'] .= Gum_html::posts_block_header_with_nav($options);
			$data['html'] .= '<div class="gum-block-loading-wrapper">';
			$data['html'] .= '<div id="gum-gb-wrapper-'.$id.'" class="gum-gb-wrapper tab-content">';
			$data['html'] .= $block_html['html'];
			$data['html'] .= '</div><!-- gum-gb-wrapper -->';
			$data['html'] .=  Gum_html::spinner();
			$data['html'] .= '</div><!-- gum-block-loading-wrapper -->';
			$data['html'] .= Gum_html::posts_block_footer($options);
			$data['html'] .= '</div><!-- .gum-grid-block-wrapper -->';
			$data['html'] .= '<script type="text/javascript">
				gumBlock.block_'.$id.'= {"block" : "posts_grid_2", "options" : '.json_encode($options).', "type" : "cat"};
			</script>';
		return $data;
	}
	/**
	* Post Grid 3 HTML
	* @param array	$options
	* @param string $class
	* @return string	HTML
	*/
	public static function posts_grid_3($options, $class=''){
		$count = 1;

		$data = array();
		$first_grid_post = '';
		$remaining_posts = '';
		$posts_helper = GumHelper::getposts($options);
		$the_query = $posts_helper['the_query'];

		$args = $options;
		if(isset($posts_helper['posts_view_count'])) $args['posts_view_count'] = $posts_helper['posts_view_count'];

		$data['post_count'] = $the_query->post_count;
		$has_review = 0;
		if($the_query->have_posts()){
			while ( $the_query->have_posts() ) { $the_query->the_post();
				// check if any post has reviews, assign a class to main div to set height etc.
				if(empty($has_review)){
					$review_html = self::get_post_review(get_the_ID());
					if(!empty($review_html) && strlen($review_html)) $has_review = 1;
				}

				$args['image_size'] = 'gum_700X450';
	 			$args['class']='col-md-6';
				$first_grid_post .= gum_html::block_1($args);

				$count++;

			}
			wp_reset_postdata();

			$review_class= '';
			if(!empty($has_review)) $review_class = 'gum-has-reviews';
			$data['html'] = "<div class='gum-grid-blocks gum-post-grid-block-3 tab-pane show active main-posts $review_class'>
							<div class='row'>
								$first_grid_post
							</div>

						<div class='clearfix'></div>
				</div><!-- gum-grid-blocks -->";
			return $data;
		}
		else return false;

	}

	public static function post_grid_3_html($options){
	$options=self::sanitize_grid_args($options);

		if(!empty($options['id'])) $id = $options['id'];
	    else{
		    $id = rand();
			$options['id'] = $id;
		}
		$data=[];
	$block_html = gum_html::posts_grid_3($options);

		$data['html']="";
		$data['html'].="<div class='gum-grid-block-wrapper gum-grid-block-3 border-box box-style-5 gum-grid-block-wrapper-".$id."'>";
		$data['html'].=Gum_html::posts_block_header_with_nav($options);
		$data['html'].="<div class='gum-block-loading-wrapper'>";
		$data['html'].="<div id='gum-gb-wrapper-".$id."' class='gum-gb-wrapper tab-content'>";
		$data['html'].=$block_html['html'];
		$data['html'].="</div><!-- gum-gb-wrapper -->";
		$data['html'].=Gum_html::spinner();
		$data['html'].="</div><!-- gum-block-loading-wrapper -->";
		$data['html'].=Gum_html::posts_block_footer($options);
		$data['html'].="</div>";
		$data['html'].="<script type='text/javascript'>";
		$data['html'].="gumBlock.block_".$id."= {'block' : 'posts_grid_3', 'options' : ".json_encode($options).", 'type' : 'cat'};";
		$data['html'].="</script>";

		return $data;
	}
	/**
	* Post Grid 4 HTML
	* @param array	$options
	* @param string $class
	* @return string	HTML
	*/
	public static function posts_grid_4($options, $class=''){

		$data = array();
		$posts_html = '';
		$posts_helper = GumHelper::getposts($options);
		$the_query = $posts_helper['the_query'];

		$args = $options;
		if(isset($posts_helper['posts_view_count'])) $args['posts_view_count'] = $posts_helper['posts_view_count'];

		$data['post_count'] = $the_query->post_count;
		$has_review = 0;

		$count = 0;

		if($the_query->have_posts()){
			while ( $the_query->have_posts() ) { $the_query->the_post();
				// check if any post has reviews, assign a class to main div to set height etc.
				if(empty($has_review)){
					$review_html = self::get_post_review(get_the_ID());
					if(!empty($review_html) && strlen($review_html)) $has_review = 1;
				}

				// Use large image if published in full width area
		 		$args['image_size'] = 'gum_700X450';
				 $args['class']='col-md-6';
				 $args['class2']=' box-5';
		 		$args['show_author']=0;

		 		if($count%2 == 0) $posts_html .= "<div class='row'>";
				$posts_html .= gum_html::block_4($args);
				if($count%2 == 1) $posts_html .= "</div>";
				$count++;


			}
			wp_reset_postdata();

			$review_class= '';
			if(!empty($has_review)) $review_class = 'gum-has-reviews';
			$data['html'] = "<div class='gum-grid-blocks gum-post-grid-block-4 tab-pane active gum-gb-row $review_class'>
							$posts_html
						<div class='clearfix'></div>

				</div><!-- gum-grid-blocks -->";
			return $data;
		}
		else return false;

	}

	public static function post_grid_4_html($options){

	$options=self::sanitize_grid_args($options);

		if(!empty($options['id'])) $id = $options['id'];
	    else{
		    $id = rand();
			$options['id'] = $id;
		}

		$data=[];
		$block_html = gum_html::posts_grid_4($options);

		$data['html']="";
		$data['html'].="<div class='gum-grid-block-wrapper gum-grid-block-4 border-box box-style-6 gum-grid-block-wrapper-".$id."'>";
		$data['html'].=Gum_html::posts_block_header_with_nav($options);
		$data['html'].="<div class='gum-block-loading-wrapper'>";
		$data['html'].="<div id='gum-gb-wrapper-".$id."' class='gum-gb-wrapper tab-content'>";
		$data['html'].=$block_html['html'];
		$data['html'].="</div><!-- gum-gb-wrapper -->";
		$data['html'].=Gum_html::spinner();
		$data['html'].="</div><!-- gum-block-loading-wrapper -->";
		$data['html'].=Gum_html::posts_block_footer($options);
		$data['html'].="</div>";
		$data['html'].="<script type='text/javascript'>";
		$data['html'].="gumBlock.block_".$id."= {'block' : 'posts_grid_4', 'options' : ".json_encode($options).", 'type' : 'cat'};";
		$data['html'].="</script>";

		return $data;
	}


	public static function posts_grid_5($options, $class=''){

		$data = array();
		$posts_html = '';
		$first_grid_post='';
		$posts_helper = GumHelper::getposts($options);
		$the_query = $posts_helper['the_query'];

		$args = $options;
		if(isset($posts_helper['posts_view_count'])) $args['posts_view_count'] = $posts_helper['posts_view_count'];

		$data['post_count'] = $the_query->post_count;
		$has_review = 0;

		$count = 0;

		if($the_query->have_posts()){
			while ( $the_query->have_posts() ) { $the_query->the_post();
				// check if any post has reviews, assign a class to main div to set height etc.
				if(empty($has_review)){
					$review_html = self::get_post_review(get_the_ID());
					if(!empty($review_html) && strlen($review_html)) $has_review = 1;
				}

				// Use large image if published in full width area


		 		if($count == 0){
		 			$args['image_size'] = 'gum_700X300';
		 			$args['class']='style-box-1 box-5 full-gd';
		 			$args['title_word_count'] = 12;
		 			$first_grid_post .= gum_html::block_4($args);
		 		}
		 		else{
		 			$args['image_size'] = 'gum_170X170';
		 			$args['class']=' ';

			 		if($count%2 == 1) $posts_html .= "<div class='row'>";
					$posts_html .= "<div class='col-md-6'>";
					$posts_html .= gum_html::block_2($args);
					$posts_html .= "</div>";
					if($count%2 == 0) $posts_html .= "</div>";
				}
				$count++;


			}

			wp_reset_postdata();

			$review_class= '';
			if(!empty($has_review)) $review_class = 'gum-has-reviews';
			$data['html'] = "<div class='gum-grid-blocks gum-post-grid-block-5 tab-pane active gum-gb-row $review_class'>
							$first_grid_post
							$posts_html


				</div><!-- gum-grid-blocks -->";
			return $data;
		}
		else return false;

	}

	public static function post_grid_5_html($options){

			$options=self::sanitize_grid_args($options);

		if(!empty($options['id'])) $id = $options['id'];
	    else{
		    $id = rand();
			$options['id'] = $id;
		}

		$data=[];
		$block_html = gum_html::posts_grid_5($options);

		$data['html']="";
		$data['html'].="<div class='gum-grid-block-wrapper gum-grid-block-5 border-box box-style-6 gum-grid-block-wrapper-".$id."'>";
		$data['html'].=Gum_html::posts_block_header_with_nav($options);
		$data['html'].="<div class='gum-block-loading-wrapper'>";
		$data['html'].="<div id='gum-gb-wrapper-".$id."' class='gum-gb-wrapper tab-content'>";
		$data['html'].=$block_html['html'];
		$data['html'].="</div><!-- gum-gb-wrapper -->";
		$data['html'].=Gum_html::spinner();
		$data['html'].="</div><!-- gum-block-loading-wrapper -->";
		$data['html'].=Gum_html::posts_block_footer($options);
		$data['html'].="</div>";
		$data['html'].="<script type='text/javascript'>";
		$data['html'].="gumBlock.block_".$id."= {'block' : 'posts_grid_5', 'options' : ".json_encode($options).", 'type' : 'cat'};";
		$data['html'].="</script>";

		return $data;
	}




	public static function posts_grid_6($options, $class=''){

		$data = array();
		$posts_html = '';
		$first_grid_post='';
		$posts_helper = GumHelper::getposts($options);
		$the_query = $posts_helper['the_query'];

		$args = $options;
		if(isset($posts_helper['posts_view_count'])) $args['posts_view_count'] = $posts_helper['posts_view_count'];

		$data['post_count'] = $the_query->post_count;
		$has_review = 0;

		$count = 0;

		if($the_query->have_posts()){
			while ( $the_query->have_posts() ) { $the_query->the_post();
				// check if any post has reviews, assign a class to main div to set height etc.
				if(empty($has_review)){
					$review_html = self::get_post_review(get_the_ID());
					if(!empty($review_html) && strlen($review_html)) $has_review = 1;
				}

				// Use large image if published in full width area


		 		if($count == 0){
		 			$args['image_size'] = 'gum_700X300';
		 			$args['class']='style-box-1 box-5 full-gd';
		 			$first_grid_post .= gum_html::block_4($args);
		 		}
		 		else{
		 			$args['image_size'] = 'gum_700X450';
		 			$args['class']='col-md-6';

			 		if($count%2 == 1) $posts_html .= "<div class='row'>";
					$posts_html .= gum_html::block_1($args);
					if($count%2 == 0) $posts_html .= "</div>";
				}
				$count++;


			}
			wp_reset_postdata();

			$review_class= '';
			if(!empty($has_review)) $review_class = 'gum-has-reviews';
			$data['html'] = "<div class='gum-grid-blocks gum-post-grid-block-6 tab-pane active gum-gb-row $review_class'>
							$first_grid_post
							$posts_html
						<div class='clearfix'></div>

				</div><!-- gum-grid-blocks -->";
			return $data;
		}
		else return false;

	}

	public static function post_grid_6_html($options){

			$options=self::sanitize_grid_args($options);

		if(!empty($options['id'])) $id = $options['id'];
	    else{
		    $id = rand();
			$options['id'] = $id;
		}

		$data=[];
		$block_html = gum_html::posts_grid_6($options);

		$data['html']="";
		$data['html'].="<div class='gum-grid-block-wrapper gum-grid-block-6 border-box box-style-6 gum-grid-block-wrapper-".$id."'>";
		$data['html'].=Gum_html::posts_block_header_with_nav($options);
		$data['html'].="<div class='gum-block-loading-wrapper'>";
		$data['html'].="<div id='gum-gb-wrapper-".$id."' class='gum-gb-wrapper tab-content'>";
		$data['html'].=$block_html['html'];
		$data['html'].="</div><!-- gum-gb-wrapper -->";
		$data['html'].=Gum_html::spinner();
		$data['html'].="</div><!-- gum-block-loading-wrapper -->";
		$data['html'].=Gum_html::posts_block_footer($options);
		$data['html'].="</div>";
		$data['html'].="<script type='text/javascript'>";
		$data['html'].="gumBlock.block_".$id."= {'block' : 'posts_grid_6', 'options' : ".json_encode($options).", 'type' : 'cat'};";
		$data['html'].="</script>";

		return $data;
	}




		public static function posts_grid_7($options, $class=''){

		$data = array();
		$posts_html = '';
		$posts_helper = GumHelper::getposts($options);
		$the_query = $posts_helper['the_query'];

		$args = $options;
		if(isset($posts_helper['posts_view_count'])) $args['posts_view_count'] = $posts_helper['posts_view_count'];

		$data['post_count'] = $the_query->post_count;
		$has_review = 0;

		$count = 0;

		if($the_query->have_posts()){
			while ( $the_query->have_posts() ) { $the_query->the_post();
				// check if any post has reviews, assign a class to main div to set height etc.
				if(empty($has_review)){
					$review_html = self::get_post_review(get_the_ID());
					if(!empty($review_html) && strlen($review_html)) $has_review = 1;
				}

				// Use large image if published in full width area
		 		$args['image_size'] = 'gum_700X450';

				$posts_html .= gum_html::block_3($args);
				$count++;


			}
			wp_reset_postdata();

			$review_class= '';
			if(!empty($has_review)) $review_class = 'gum-has-reviews';
			$data['html'] = "<div class='gum-grid-blocks gum-post-grid-block-7 tab-pane active gum-gb-row $review_class'>
							$posts_html
						<div class='clearfix'></div>

				</div><!-- gum-grid-blocks -->";
			return $data;
		}
		else return false;

	}

	public static function post_grid_7_html($options){

			$options=self::sanitize_grid_args($options);

		if(!empty($options['id'])) $id = $options['id'];
	    else{
		    $id = rand();
			$options['id'] = $id;
		}

		$data=[];
		$block_html = gum_html::posts_grid_7($options);

		$data['html']="";
		$data['html'].="<div class='gum-grid-block-wrapper gum-grid-block-7 border-box box-style-6 gum-grid-block-wrapper-".$id."'>";
		$data['html'].=Gum_html::posts_block_header_with_nav($options);
		$data['html'].="<div class='gum-block-loading-wrapper'>";
		$data['html'].="<div id='gum-gb-wrapper-".$id."' class='gum-gb-wrapper tab-content'>";
		$data['html'].=$block_html['html'];
		$data['html'].="</div><!-- gum-gb-wrapper -->";
		$data['html'].=Gum_html::spinner();
		$data['html'].="</div><!-- gum-block-loading-wrapper -->";
		$data['html'].=Gum_html::posts_block_footer($options);
		$data['html'].="</div>";
		$data['html'].="<script type='text/javascript'>";
		$data['html'].="gumBlock.block_".$id."= {'block' : 'posts_grid_7', 'options' : ".json_encode($options).", 'type' : 'cat'};";
		$data['html'].="</script>";

		return $data;
	}

	/**
	* Recent Posts with pagination
	* @param array $options
	* @param string $class
	* @return string	HTML
	*/
	public static function recent_posts_with_pagination($options, $class=''){
		$count = 1;
		if(empty($options['post_listing'])){

			$custom_options = array('pagebuilder' => true);
			$Gum_blog_html = new Gum_blog_html($custom_options);
			$blog_options = $Gum_blog_html->get_blog_options();

			foreach($blog_options as $key=>$val) $options[$key] = $val;
		}
		$data = array();
		$posts_html = '';

		if(isset($options['post_listing'])) $post_listing_block = $options['post_listing'];
		else $post_listing_block = 'block_3';


		$options['posts_per_page'] = get_option( 'posts_per_page' );
		$paged = ( get_query_var('page') ) ? get_query_var('page') : 1;
		if($paged > 1) $options['gum_post_offset'] = $options['posts_per_page'] * ( $paged - 1 );

		$posts_helper = GumHelper::getposts($options);
		$the_query = $posts_helper['the_query'];
		//args for post block.
		if(isset($options['args'])) $args = $options['args'];
		else $args = $options;


		if(isset($options['row_class'])) $args['row_class'] = $options['row_class'];
		if(isset($options['arg_class'])) $args['class'] .= $options['arg_class'];

		$data['post_count'] = $the_query->post_count;
		$has_review = 0;
		$arg_class = $args['class'];
		if($the_query->have_posts()){
			while ( $the_query->have_posts() ) { $the_query->the_post();
				// check if any post has reviews, assign a class to main div to set height etc.
				$class = '';
				if(empty($has_review)){
					$review_html = self::get_post_review(get_the_ID());
					if(!empty($review_html) && strlen($review_html)) $has_review = 1;
				}

				if(0 == $count % 2 ) $odd_event = " gum-block-even ";
				else  $odd_event = " gum-block-odd ";

				 $class .= $odd_event.' gum-grid-'.$post_listing_block.'-'.$count.' ';

				 $args['class'] = $arg_class.$class;

				$posts_html .= gum_html::$post_listing_block($args);
				if(0 == $count % 2 ) $posts_html .= '<div class="clearfix"></div>';

				$count++;

			}
			wp_reset_postdata();

			$review_class= '';
			if(!empty($has_review)) $review_class = 'gum-has-reviews';
			$data['html'] = "<div class='gum-grid-blocks gum-post-grid-block-3 gum-gb-row $review_class'>
							$posts_html
						<div class='clearfix'></div>

				</div><!-- gum-grid-blocks -->";


			$data['html'] .= gum_theme_pagination(false, $the_query);

			return $data;
		}
		else return false;


	}

	/**
	* Spinner
	* @param string $class
	* @param bolean $show_loading_msg
	* @return string	HTML
	*/
	public static function spinner($class='gum-block-loading gum-loader', $show_loading_msg=true){

		$html = '<div class="'.$class.'" style="display:none;">'.Gum_html::spinner_code().'</div>';
		if($show_loading_msg) $html .= '<div class="loading-msg"></div>';
		return $html;
	}

	/**
	* Simple Spinner - without wrapper div
	* @return string	HTML
	*/
	public static function simple_spinner(){

		$html = '<div class="gum-loader" style="display:none;">'.Gum_html::spinner_code().'</div>';
		return $html;
	}

	/**
	* Spinner code - plain spinner html
	* @return string	HTML
	*/
	public static function spinner_code(){

		$html = '<div class="spinner"><div class="bounce1"></div><div class="bounce2"></div><div class="bounce3"></div></div>';
		return $html;
	}

	/**
	* Mega Menu direction icon
	* @return string	HTML
	*/
	public static function mega_menu_direction_icon(){

		$html = '<span class="fa fa-angle-down" aria-hidden="true"></span>';

		return $html;
	}


	/**
	* Show Review
	* @return string	HTML
	*/
	public static function show_review(){

		/**
		* Review MetaFields
		* str gum_is_review_post $review_enable = array('no'=>'No', 'star'=>'Star', "percentage" => "Percentage", "points" => "Points");
		* str gum_review_heading
		* array gum_post_review
		* str gum_post_review_total
		* str gum_review_desc_heading
		* str gum_post_review_desc
		*/
		$post_id = get_the_ID();
		if(!empty($post_id)){
			$gum_is_review_enabled = get_post_meta($post_id, 'gum_is_review_post', true);
			if(!empty($gum_is_review_enabled) && $gum_is_review_enabled != 'no'){

				if($gum_is_review_enabled == 'star') echo self::review_star();

			}
		}

	}

	/**
	* Review Star - Star review html
	* @return string	HTML
	*/
	public static function review_star(){
		global $gumtheme_translations;

		$post_id = get_the_ID();
		$gum_review_heading = get_post_meta($post_id, 'gum_review_heading', true);
		$gum_post_review = get_post_meta($post_id, 'gum_post_review', true);
		$gum_post_review_total = get_post_meta($post_id, 'gum_post_review_total', true);
		$gum_review_desc_heading = get_post_meta($post_id, 'gum_review_desc_heading', true);
		$gum_post_review_desc = get_post_meta($post_id, 'gum_post_review_desc', true);

		$overall_text = (!empty($gumtheme_translations['review_overall'])) ? $gumtheme_translations['review_overall'] : 'Overall';
		$html = "<div class='gum-single-review-wrapper gum-review-star-wrapper'>";
		$html .= "<div class='gum-single-review gum-review-star'>";
		if(strlen($gum_review_heading) > 1) $html .= "<h3>$gum_review_heading</h3>";
		if(!empty($gum_post_review_desc) && strlen($gum_post_review_desc) > 0 ) $html .= "<p>$gum_post_review_desc</p>";
		if(!empty($gum_post_review['item_title'])) $review_titles = $gum_post_review['item_title'];
		if(!empty($gum_post_review['item_star'])) $item_star = $gum_post_review['item_star'];
		if(!empty($review_titles) && !empty($item_star)){
			$count = count($review_titles);

			for($i=0; $i <= $count; $i++){
				if(!empty($review_titles[$i]) && strlen($review_titles[$i]) > 3 && !empty($item_star[$i]) &&  strlen($item_star[$i]) > 0 ){
					$html .= "<div class='gum-single-review-item gum-review-star-item gum-review-star-item-$i'>";
					$html .= "<div class='pull-left'>".$review_titles[$i]."</div>";
					$html .= "<div class='pull-right'>".Gum_block::get_review_stars($item_star[$i])."</div>";
					$html .= "<div class='clearfix'></div>";
					$html .= "</div>";
				}
			}

		}
		$html .= "<div class='clearfix'></div>";

		$html .= "<div class='gum-single-review-total-wrapper'><div class='gum-single-review-total'>";
		$html .= Gum_block::get_review_stars($gum_post_review_total);
		$html .= "<span class='review-test'>".$overall_text." </span>";
		$html .= "</div></div>";

		$html .= "<div class='clearfix'></div>";

		$html .= "</div>";
		$html .= "</div>";

		return $html;

	}

	/**
	* Get post Categories
	* @return string	HTML
	*/
	public static function get_post_categories(){
		global $post;

		if(empty($post)){
			if ( function_exists('gumError')) gumError("post_id not defined. you must call this function inside loop. get_the_post_views()");
			return false;
		}
		$categories_list = get_the_category_list( esc_html__( '', 'gumtheme' ), '', $post->ID );
		if ( $categories_list) {
			printf( '<span class="cat-links">' . esc_html__( '%1$s', 'square' ) . '</span>', $categories_list ); // WPCS: XSS OK.
		}


	}

	/**
	* Get Post Date
	* @return string	HTML
	*/
	public static function get_post_date(){

		global $post, $gumtheme_options;
		if(empty($post)){
			if ( function_exists('gumError')) gumError("post_id not defined. you must call this function inside loop. get_the_post_views()");
			return false;
		}
		$show_date = (isset($gumtheme_options['show_post_date']))? $gumtheme_options['show_post_date'] : self::$single_post_setting['show_post_date'];
		$date_type = (isset($gumtheme_options['post_date_type']))? $gumtheme_options['post_date_type'] : self::$single_post_setting['post_date_type'];
		$date_format = (isset($gumtheme_options['post_date_format']))? $gumtheme_options['post_date_format'] : self::$single_post_setting['post_date_format'];
		$post_date_pretext = (isset($gumtheme_options['post_date_pretext']))? $gumtheme_options['post_date_pretext'] : self::$single_post_setting['post_date_pretext'];

		$post_date = '';
		if($show_date == 1){
			if($date_type == 'date_ago'){
				$post_date = human_time_diff( get_the_date('U', $post->ID), current_time('timestamp') ) .' '. __('ago', 'gumtheme');
			}
			else{

				$post_date = get_the_date($date_format, $post->ID);
			}

			$post_date = '<span class="post_publish_date">'.$post_date_pretext.' <time class="entry-date published updated" datetime="'.$post_date.'">'.$post_date.'</time></span>';
		}

		return $post_date;

	}

	/**
	* Get Post Author
	* @return string	HTML
	*/
	public static function get_post_author(){

		global $post, $gumtheme_options;

		if(empty($post)){
			if ( function_exists('gumError')) gumError("post_id not defined. you must call this function inside loop. get_the_post_views()");
			return false;
		}
		$post_id = $post->ID;
		$author_id =  $post->post_author;
		$show_date = (isset($gumtheme_options['show_post_date']))? $gumtheme_options['show_post_date'] : self::$single_post_setting['show_post_date'];
		$show_post_author = (isset($gumtheme_options['show_post_author']))? $gumtheme_options['show_post_author'] : self::$single_post_setting['show_post_author'];
		$post_author_pretext = (isset($gumtheme_options['post_author_pretext']))? $gumtheme_options['post_author_pretext'] : self::$single_post_setting['post_author_pretext'];

		$html = '';
		if($show_post_author == 1 && !empty($author_id)){
			$byline = sprintf(
			esc_html_x( '%s', 'post author', 'square' ),
			'<span class="author vcard"><a class="url fn n" href="' . esc_url( get_author_posts_url( $author_id ) ) . '">' . esc_html( get_the_author_meta( 'nickname', $author_id ) ) . '</a></span>'
			);
			$class = '';
			if($show_date == 1) $class = 'gum-divider ';
			$html = '<span class="'.$class.'byline">' .$post_author_pretext.' ' .$byline . '</span>'; // WPCS: XSS OK.
		}

		return $html;

	}

	/**
	* Get author image
	* @return string	HTML
	*/
	public static function get_post_author_image(){

		global $post, $gumtheme_options;
		if(empty($post)){
			if ( function_exists('gumError')) gumError("post_id not defined. you must call this function inside loop. get_the_post_views()");
			return false;
		}
		$show_post_author_image = (isset($gumtheme_options['show_post_author_image']))? $gumtheme_options['show_post_author_image'] :  self::$single_post_setting['show_post_author_image'];
		$html = '';

		if($show_post_author_image == 1) {
			$post_id = $post->ID;
			$author_id =  $post->post_author;

			$html = '<div class="author-image">
						'.get_avatar( $author_id, 32 ).'
					</div><!-- author-image -->';
		}

		return $html;

	}

	/**
	* Get post views
	* @return string	HTML
	*/
	public static function get_post_views(){

		$html = '';

		if(!GumHelper::is_post_count_enable()) return $html;

		global $GUM_Postcount, $gumtheme_options;


		$show_post_views = (isset($gumtheme_options['show_post_views']))? $gumtheme_options['show_post_views'] :  self::$single_post_setting['show_post_views'];
		if(empty($show_post_views)) return $html;

		$icon = GumHelper::get_postviews_icon();

		if(in_the_loop()) $post_id = get_the_ID();
		else{
			global $post;
			$post_id = $post->ID;
		}
		if(!empty($post_id)) $html = '<span class="post-view-count">'.$icon.' '.$GUM_Postcount->get_post_view_count($post_id).' </span>';
		else{
			if ( function_exists('gumError')) gumError("post_id not defined. you must call this function inside loop. get_the_post_views()");
		}


		return $html;

	}

	/**
	* Get post comments
	* @return string	HTML
	*/
	public static function get_post_comment(){

		global $gumtheme_options;
		$show_post_comment_count = (isset($gumtheme_options['show_post_comment_count']))? $gumtheme_options['show_post_comment_count'] :  self::$single_post_setting['show_post_comment_count'];
		$html = '';

		if($show_post_comment_count == 1){

			$num_comments = get_comments_number(); // get_comments_number returns only a numeric value
			if($num_comments > 0) $html = '<span class="post-commtent-count"><i class="fa fa-comment-o" aria-hidden="true"></i> '.$num_comments.'</span>';

		}

		return $html;

	}

	/**
	* Get post likes
	* @return string	HTML
	*/
	public static function get_post_likes(){

		$html = '';
		if(!GumHelper::is_post_likes_enable()) return $html;

		global $GUM_Postlike, $gumtheme_options;

		$show_post_likes = (isset($gumtheme_options['show_post_likes']))? $gumtheme_options['show_post_likes'] :  self::$single_post_setting['show_post_likes'];
		if(empty($show_post_likes)) return $html;


		$icon = GumHelper::get_likes_icon();

		if(in_the_loop()) $post_id = get_the_ID();
		else{
			global $post;
			$post_id = $post->ID;
		}
		if ( empty($post_id) && function_exists('gumError')) gumError("post_id not defined. you must call this function inside loop. get_the_post_comment()");

		$class = '';
		if(Gum_postlike_counter::check_already_liked_cookie($post_id, $GUM_Postlike->counter->cookie)) $class= 'voted disabled';

		$html = '<a href="#" class="gum-post-like '.$class.'">
			<span class="post_heart">'.$icon.'</span>
			<span class="post_love_count">'.$GUM_Postlike->get_likes_count($post_id).'</span>
		</a>';




		return $html;

	}

	/**
	* Get single post title
	* @return string	HTML
	*/
	public static function get_single_post_title(){
		global $post;
		if(empty($post)){
			if ( function_exists('gumError')) gumError("post_id not defined. you must call this function inside loop. get_the_post_views()");
			return false;
		}
		$post_id = $post->ID;

		$gum_post_subheading = get_post_meta($post_id, 'gum_post_subheading', true);
		$html = '<h1 class="heading entry-title post_title" itemprop="headline">'.get_the_title($post_id).'</h1>';
		if(!empty($gum_post_subheading)) $html .= '<div class="gum-single-post-subheading"><h3>'.$gum_post_subheading.'</h3></div>';
		return $html;
	}

	/**
	* Get single post header
	* @return string	HTML
	*/
	public static function get_single_post_header(){

		echo '<div class="linke-cate">';
		Gum_html::get_post_categories();
		echo '</div>';
		echo Gum_html::get_single_post_title();
	}
	public static function get_single_post_author_views($show_singlepost_meta='111'){

		$num_of_comments=Gum_html::get_post_comment();
		if($num_of_comments == null)
			$num_of_comments='<span class="number_of_comments">0</span>';

		$num_of_likes=Gum_html::get_post_likes();
		if($num_of_likes == null)
			$num_of_likes=0;
			?>
		<div class="pull-left">
			<?php switch($show_singlepost_meta){
				case '000':
					echo '';
					break;
				case '001':
					echo $num_of_likes;
					break;
				case '010':
					echo $num_of_comments;
					break;
				case '100':
					echo Gum_html::get_post_views();
					break;
				case '011':
					echo $num_of_comments;
					echo $num_of_likes;
					break;
				case '101':
					echo Gum_html::get_post_views();
					echo $num_of_likes;
					break;
				case '110':
					echo Gum_html::get_post_views();
					echo $num_of_comments;
					break;
				case '111':
					echo Gum_html::get_post_views();
					echo $num_of_likes;
					echo $num_of_comments;
					break;
				default:
					echo '';
				}
			?>
		</div><!-- pull-right -->
	<?php
	}

	/**
	* Get single post
	* @return string	HTML
	*/
	public static function get_single_post(){
		global $post, $gumtheme_options;
		$post_id = $post->ID;
		/**
			* Post format
		*/
		$post_format = get_post_format( $post_id );
		if($post_format == "video"){
			$gum_single_post_template = "video";
		}
		else{
			$post_template = get_post_meta($post_id, 'gum_single_post_template', true);

			if(!empty($post_template)){
				if($post_template == 'default'){
					$gum_single_post_template = (!empty($gumtheme_options['gum_single_post_template']))? $gumtheme_options['gum_single_post_template'] :  $post_template;
				}else {

					$gum_single_post_template = $post_template;
				}
			}
			else{
				$gum_single_post_template = (!empty($gumtheme_options['gum_single_post_template']))? $gumtheme_options['gum_single_post_template'] :  'default';
			}
		}

		$single_post_method = "get_the_single_post_tpl_".$gum_single_post_template;
		self::$single_post_method();


	}

	/**
	* Get single post sidebar id
	* @return int	sidebar id
	*/
	public static function get_single_post_sidebar_id(){
		global $post, $gumtheme_options;
		/**
			* Sidebar id
		*/
		$gum_sidebar_id = 'sidebar-1';
		if(is_singular() && !empty($post)){
			//if(get_post_type($post->ID) == "post"){
				$post_sidebar = get_post_meta($post->ID, 'gum_post_sidebar', true);
				if(!empty($post_sidebar)){
					if($post_sidebar == 'default'){
						$gum_sidebar_id = (isset($gumtheme_options['gum_post_sidebar']))? $gumtheme_options['gum_post_sidebar'] :  'sidebar-1';
					}else {

						$gum_sidebar_id = $post_sidebar;
					}
				}
				else {
					$gum_sidebar_id = (!empty($gumtheme_options['gum_post_sidebar']))? $gumtheme_options['gum_post_sidebar'] :  'sidebar-1';
				}
			//}
		}
		return $gum_sidebar_id;
	}

	/**
	* Get the post footer
	* @return string	HTML
	*/
	public static function get_the_post_footer(){
		global $post, $gumtheme_options;

		$post_id = get_the_ID();
		$gum_post_source_name = get_post_meta($post->ID, 'gum_post_source_name', true);
		$gum_post_source_url = get_post_meta($post->ID, 'gum_post_source_url', true);
		$gum_post_via_name = get_post_meta($post->ID, 'gum_post_via_name', true);
		$gum_post_via_url = get_post_meta($post->ID, 'gum_post_via_url', true);
		$gum_post_source_name = get_post_meta($post->ID, 'gum_post_source_name', true);
		if(!empty($gum_post_source_name)):
		?>
			<div class="gum-post-item gum-post-source">
				<span class="gum-post-item-title"><?php _e("Source", "gumtheme")?></span>
				<?php if(!empty($gum_post_source_url)) echo "<a href='$gum_post_source_url' class='item_list'>";
					else echo "<span class='item_list'>";
				?>
				<?php echo $gum_post_source_name; ?>
				<?php if(!empty($gum_post_source_url)) echo "</a>";
					else echo "</span>";
				?>
				<div class="clearfix"></div>
			</div><!-- gum-post-item -->
		<?php
		endif;
		if(!empty($gum_post_via_name)):
		?>
			<div class="gum-post-item gum-post-via">
				<span class="gum-post-item-title"><?php _e("Via", "gumtheme")?></span>
				<?php if(!empty($gum_post_via_url)) echo "<a href='$gum_post_via_url' class='item_list'>";
					else echo "<span class='item_list'>";
				?>
				<?php echo $gum_post_via_name; ?>
				<?php if(!empty($gum_post_via_url)) echo "</a>";
					else echo "</span>";
				?>
				<div class="clearfix"></div>
			</div><!-- gum-post-item -->
		<?php
		endif;
		$tags_list = get_the_tag_list( '', esc_html__( '', 'gumtheme' ) );
		if ( $tags_list ) {
			printf( '<span class="gum-post-item gum-tags-links"><span class="gum-post-item-title">'.__("Tags", "gumtheme").'</span> ' . esc_html__( '%1$s', 'gumtheme' ) . '<div class="clearfix"></div></span>', $tags_list ); // WPCS: XSS OK.
		}


	}

	/**
	* Get single post sidebar position
	* @return string	HTML
	*/
	public static function get_single_post_sidebar_position(){
		global $post, $gumtheme_options;
		/**
			* Sidebar position
		*/
		$post_sidebar_position = get_post_meta($post->ID, 'gum_single_post_sidebar_position', true);
		if(!empty($post_sidebar_position)){
			if($post_sidebar_position == 'default'){
				$gum_sidebar_position = (isset($gumtheme_options['gum_single_post_sidebar_position']))? $gumtheme_options['gum_single_post_sidebar_position'] :  'default';

			}else {

				$gum_sidebar_position = $post_sidebar_position;

			}
		}
		else {
			$gum_sidebar_position = (!empty($gumtheme_options['gum_single_post_sidebar_position']))? $gumtheme_options['gum_single_post_sidebar_position'] :  'default';
		}
		if($gum_sidebar_position == 'default') $gum_sidebar_position="right";

		return $gum_sidebar_position;
	}

	/**
	* get the single post template default
	* @return string	HTML
	*/
	public static function get_the_single_post_tpl_default(){


		get_template_part( 'template-parts/content', 'single' );


	}

	/**
	* get the single post template Style1
	* @return string	HTML
	*/
	public static function get_the_single_post_tpl_style1(){

		get_template_part( 'template-parts/content', 'single' );

	}

	/**
	* get the single post template Style 2
	* @return string	HTML
	*/
	public static function get_the_single_post_tpl_style2(){

		get_template_part( 'template-parts/content', 'single-style2' );

	}

	/**
	* get the single post template Style 3
	* @return string	HTML
	*/
	public static function get_the_single_post_tpl_style3(){

		get_template_part( 'template-parts/content', 'single-style3' );

	}

	/**
	* get the single post template video
	* @return string	HTML
	*/
	public static function get_the_single_post_tpl_video(){

		get_template_part( 'template-parts/content', 'single-video' );

	}

	/**
	* Ajax search results
	* @param array $arg
	* @return string	HTML
	*/
	public static function ajax_search_results($arg){
		$is_mob = $arg['is_mob'];
		$search_query = $arg['search_query'];
		$postQuery = GumHelper::search_posts($search_query);
	 	$data['has_posts'] = 0;
	 	$data['no_posts_msg'] = __('<h6 class="no-result">No search results found</h6>', 'gumtheme');

		if ( $postQuery->have_posts() ) {
			$post_args = array (
	 			'class' => 'col-md-3',
	 			'show_cat' => 1,
				'show_date' => 0,
				'show_author' => 0,
				'show_views' => 0,
				'show_likes' => 0,
				'show_comment_count' => 0,
				'show_excerpt' => 0,
				'date_type' => 'date_ago',
				'custom_date_format' => 'M j, Y',
				'show_title' => '1',
				'title_word_count' => 8,
				'excerpt_word_count' => 20,
				'image_size' => 'gum_400X240',

	 		);
			$data['has_posts'] = 1;
			$count=0;
			$html = '<div class="search_posts"><div class="row">';
			while ( $postQuery->have_posts() ) {
				$postQuery->the_post();

				$html .=gum_html::search_block($post_args);

				$count++;
			}

			$html .= '</div>
			<div class="gum_search_link pull-right"><a href="'.get_search_link( $search_query ).'" class="btn btn-primary">'.__('All results','gumtheme').' <i class="fa fa-angle-right" aria-hidden="true"></i></a></div>
			<div class="clearfix"></div>
			</div><!-- .search_posts -->';
			$data['html'] = $html;
			wp_reset_postdata();
		}

		return $data;

	}

	/**
	* Category page posts
	* @param array $post_options
	* @param boolean $in_loop
	* @return string	HTML
	*/
	public static function category_page_posts($post_options, $in_loop=true){



		if($in_loop){//while calling from category it is in loop

			$cat_post_listing_block = $post_options['post_grid'];

			$args = $post_options['args'];
			//$args['show_title'] = "1";
			//$args['title_word_count'] = "6";
			//$args['show_date'] = "1";
			//$args['show_excerpt'] = "1";
			//$args['show_author']= "1";
			//$args['read_more'] = "1";
			//$args['show_cat'] = "0";
			//$args['show_likes'] = "0";
			//$args['show_comment_count'] = "0";
			//$args['show_views'] = "0";

			 if(method_exists('gum_html', $cat_post_listing_block))
			 	echo gum_html::$cat_post_listing_block($args);
			 else gumError("Method ".$cat_post_listing_block." doesn't exist in Gum_html class. Use a different option");
		}
		else{

			$data = array();
			$data['html'] = '';
			$cat_post_listing_block = $post_options['post_grid'];


			$options = array(
				'category_id' => $post_options['cat_id'],
				'posts_per_page' => $post_options['ppp'],
				'gum_post_offset' => $post_options['offset'],

			);
			if(empty($args)) $args = array();

			if(isset($post_options['args'])) $args = maybe_unserialize(stripslashes($post_options['args']));
			$posts_helper = GumHelper::getposts($options);
			$the_query = $posts_helper['the_query'];


			if($the_query->have_posts()){
				$data['post_count'] = $the_query->post_count;
				$arg_class = $args['class'];
				$count = 1;
				while ( $the_query->have_posts() ) : $the_query->the_post();

					if(0 == $count % 2 ) $odd_even_class = " gum-block-even ";
					else  $odd_even_class = " gum-block-odd ";

					$args['class'] = $arg_class.$odd_even_class;
					$args['show_title'] = "1";
					$args['title_word_count'] = "6";
					$args['show_date'] = "1";
					$args['show_excerpt'] = "1";
					$args['read_more'] = "1";
					$args['show_cat'] = "0";
					$args['show_likes'] = "0";
					$args['show_comment_count'] = "0";
					$args['show_views'] = "0";


					//$args['class'] = '';
					if(method_exists('gum_html', $cat_post_listing_block))
						$data['html'] .= gum_html::$cat_post_listing_block($args);
					else $data['html'] .= "Method ".$cat_post_listing_block." doesn't exist in Gum_html class. Use a different option";

					if($cat_post_listing_block == 'block_3' && 0 == $count % 2) $data['html'] .= "<div class='clearfix'></div>";
					$count++;
				endwhile;
				wp_reset_postdata();

			}

			return $data;


		}
	}

	/**
	* Get Category options
	* @param int $cat_id
	* @return string	HTML
	*/
	public static function get_cat_options($cat_id=0){

		global $gumtheme_options, $gum_cat_metafields;

		$cat_option = get_option( "gum_cat_".$cat_id);

		if(function_exists('gum_cat_metafields')){

			$gum_cat_metafields = gum_cat_metafields();

			if(!empty($gum_cat_metafields['fields'])){

				foreach($gum_cat_metafields['fields'] as $field){
					$id = $field['id'];
					if(empty($cat_option[$id]) || ( isset($cat_option[$id]) && $cat_option[$id] == 'default')){

						if(isset($gumtheme_options[$id]) && $gumtheme_options[$id] != 'default') $cat_option[$id] = $gumtheme_options[$id];
						elseif(isset($field['default'])) $cat_option[$id] = $field['default'];

					}
				}

			}

		}

		return $cat_option;
	}

	/**
	* Get theme post options
	* @return string	HTML
	*/
	public static function get_theme_post_options(){

		global $gumtheme_options;
		$blog_options = array();
		if(function_exists('gum_theme_options_section')){

			$sections = gum_theme_options_section();
			$blog_global_settings = $sections['blog_global_settings'];

			if(!empty($blog_global_settings)){

				foreach($blog_global_settings as $field){
					$id = $field['id'];

					if(isset($gumtheme_options[$id]) && $gumtheme_options[$id] != 'default') $blog_options[$id] = $gumtheme_options[$id];
					elseif(isset($field['default'])) $blog_options[$id] = $field['default'];



				}

			}

		}

		return $blog_options;
	}

	/**
	* Get single page title in loop
	* @return string	HTML
	*/
	public static function get_single_page_title_loop(){
		global $gumtheme_options;

		$post_id = get_the_ID();
		$show_title = get_post_meta($post_id, 'gum_show_title', true);

		if($show_title == 'no') $title = '';
		else $title = '<h1 class="entry-title">'.get_the_title().'</h1>';
		return $title;
	}

}
