<?php
/**
 * Template part for displaying single posts.
 *
 * @package square
 */

global  $post, $GUM_Postlike, $GUM_Postcount, $gumtheme_ads;

$post_id = $post->ID;

$gum_sidebar_position = Gum_html::get_single_post_sidebar_position();

$div_row_class = "row gum-row";
$article_div_wrapper_class = "col-sm-8 col-md-8";
$article_div_row_class = "gum-row";
// if full page then don't add col-* and row classes
if(!empty($gum_sidebar_position) && $gum_sidebar_position == 'none'){
	$div_row_class = "";
	$article_div_wrapper_class = "";
	$article_div_row_class = "";
}
if ( has_post_thumbnail($post_id) ){

	$image = get_the_post_thumbnail_url( $post_id, 'gum_970X600' );
}

if(!empty($gum_sidebar_position) && $gum_sidebar_position == 'left') $div_row_class .= " content_left_sidebar";
else if(!empty($gum_sidebar_position) && ( $gum_sidebar_position == 'right' ||  $gum_sidebar_position == 'default')) $div_row_class .= " content_right_sidebar";
else $div_row_class .= " content_none_sidebar";
?>

<div class="gum-single-post gum-post-style3 <?php echo $div_row_class; ?> update-single-style">
	<div class="col-sm-12 frame-imagee">
		<div class="img-holder"><!--------- img-holder --------->
			<div class="frame"><!-------- frame ------->
				<div class="inner-frame">	
				</div>
				<div class="img-set">
					<img src="<?php echo $image; ?>" class="img-fluid">
				</div>
			</div>			
		</div>
	</div>
	
	<?php if(!empty($gum_sidebar_position) && $gum_sidebar_position == 'left') get_sidebar(); ?>

	<div id="primary" class="content-area gum-single-post-blog <?php echo $article_div_wrapper_class;?>">
		<main id="main" class="site-main <?php echo $article_div_row_class;?>" role="main">
			<?php 

			/** Ad - Footer*/
			if(class_exists('GumHelper') && !empty($gumtheme_ads['post']['post_top_ad_enable'])) GumHelper::show_ad($gumtheme_ads['post']['post_top_ad_enable'], $gumtheme_ads['post']['post_top_ad_code'], $args= array('class'=>'gum-banner-post-top')); 
			?>
			<?php while ( have_posts() ) : the_post(); ?>
				<article id="post-<?php the_ID(); ?>" <?php post_class('post-item'); ?> itemscope="" itemtype="http://schema.org/BlogPosting">

					<div class="entry-content entry-header-wrapperad">
						<?php Gum_html::get_single_post_header(); ?>
					         <div class="post_content" itemprop="articleBody">
							 	<?php the_content(); ?>
						     </div><!-- .post_content -->
					</div><!-- .entry-content -->						




					<footer class="entry-footer">
						<div class="post-social-share">
							<?php 
							gum_html::get_the_socialshare_icons_header(); 
							?>
						</div><!-- post-social-share -->
						<?php Gum_html::get_the_post_author_info(); ?>
						<?php Gum_html::related_posts(); ?>
						<?php Gum_html::show_review(); ?>
						<?php Gum_html::get_the_post_footer(); ?>
					</footer><!-- .entry-footer -->
					<?php 
						/** Ad - Footer*/
						if(class_exists('GumHelper') && !empty($gumtheme_ads['post']['post_bottom_ad_enable'])) GumHelper::show_ad($gumtheme_ads['post']['post_bottom_ad_enable'], $gumtheme_ads['post']['post_bottom_ad_code'], $args= array('class'=>'gum-banner-post-bottom')); 
					?>

					<?php Gum_html::get_the_author_posts_widget(); ?>
					
				</article><!-- #post-## -->
				
				<?php
					// If comments are open or we have at least one comment, load up the comment template.
					if ( comments_open() || get_comments_number() ) :
						comments_template();
					endif;
				?>
			<?php endwhile; // End of the loop. ?>
		</main><!-- #main -->
	</div><!-- #primary -->
	<?php if(!empty($gum_sidebar_position) && ( $gum_sidebar_position == 'right' )) get_sidebar(); ?>
</div><!-- gum-single-post -->

